function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
import React from 'react';
import Util from '../utils';
import { ADD_EDGE_ID } from '../utils/graph';
import { createUuid } from '../utils/string';
var addEdge = Util.addEdge;
var AddRelation = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(AddRelation, _React$PureComponent);
  var _super = _createSuper(AddRelation);
  function AddRelation() {
    var _this;
    _classCallCheck(this, AddRelation);
    _this = _super.apply(this, arguments);
    _this.dragging = null;
    _this.onOk = function () {
      if (!_this.dragging) return;
      var _this$props$options = _this.props.options,
        options = _this$props$options === void 0 ? {} : _this$props$options;
      var onOk = options.onOk;
      var model = _this.dragging.get('model');
      var source = model.source,
        target = model.target;
      onOk === null || onOk === void 0 ? void 0 : onOk({
        source: source,
        target: target
      });
    };
    _this.dragEdge = function (e) {
      var edge = e.item,
        canvasX = e.canvasX,
        canvasY = e.canvasY;
      if (edge.getID() !== ADD_EDGE_ID) return;
      var graph = _this.props.graph || _this.context.graph;
      graph.updateItem(edge, {
        target: {
          x: canvasX,
          y: canvasY
        }
      });
      _this.dragging = edge;
    };
    _this.drop = function (e) {
      var _a, _b;
      if (!_this.dragging) return;
      var item = e.item;
      if (!item || ((_a = item.isCanvas) === null || _a === void 0 ? void 0 : _a.call(item)) || ((_b = item.getType) === null || _b === void 0 ? void 0 : _b.call(item)) !== 'node') _this.cancelAdding();
      var graph = _this.props.graph || _this.context.graph;
      graph.updateItem(_this.dragging, {
        id: "edge-".concat(createUuid),
        target: item.getID(),
        type: 'graphin-line'
      });
      _this.onOk();
      _this.cancelAdding();
    };
    _this.cancelAdding = function () {
      var graph = _this.props.graph || _this.context.graph;
      _this.dragging = null;
      graph.removeItem(ADD_EDGE_ID);
    };
    _this.handleAddRelation = function () {
      var currentItem = _this.props.currentItem;
      var graph = _this.props.graph || _this.context.graph;
      var sourceId = currentItem === null || currentItem === void 0 ? void 0 : currentItem.get('id');
      addEdge(sourceId, graph);
    };
    return _this;
  }
  _createClass(AddRelation, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var graph = this.props.graph || this.context.graph;
      graph.on('edge:drag', this.dragEdge);
      graph.on('drop', this.drop);
      graph.on('click', this.cancelAdding);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var graph = this.props.graph || this.context.graph;
      graph.off('edge:drag', this.dragEdge);
      graph.off('drop', this.drop);
      graph.off('click', this.cancelAdding);
    }
  }, {
    key: "render",
    value: function render() {
      var name = this.props.name;
      return /*#__PURE__*/React.createElement("a", {
        onClick: this.handleAddRelation
      }, name);
    }
  }]);
  return AddRelation;
}(React.PureComponent);
AddRelation.defaultProps = {
  options: {
    onOk: function onOk() {}
  }
};
export default AddRelation;