"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = require("@antv/algorithm");
var _giSdk = require("@antv/gi-sdk");
var _graphin = _interopRequireWildcard(require("@antv/graphin"));
var _antd = require("antd");
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
var _ClusterTable = _interopRequireDefault(require("../ClusterTable"));
var _i18n = _interopRequireDefault(require("../i18n"));
var _index = _interopRequireDefault(require("../utils/index"));
require("./index.less");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var ClickSelect = _graphin.Behaviors.ClickSelect;
var CommunityDetectionAlgorithm;
(function (CommunityDetectionAlgorithm) {
  CommunityDetectionAlgorithm["KCore"] = "k-core";
  CommunityDetectionAlgorithm["louvain"] = "louvain";
  CommunityDetectionAlgorithm["iLouvain"] = "i-louvain";
  CommunityDetectionAlgorithm["ConnectedComponent"] = "connected-component";
})(CommunityDetectionAlgorithm || (CommunityDetectionAlgorithm = {}));
var CommunityDetection = function CommunityDetection(props) {
  var controlledValues = props.controlledValues,
    onOpen = props.onOpen;
  var _useContext = (0, _giSdk.useContext)(),
    data = _useContext.data,
    graph = _useContext.graph,
    updateHistory = _useContext.updateHistory;
  var _useState = (0, _react.useState)(CommunityDetectionAlgorithm.KCore),
    _useState2 = _slicedToArray(_useState, 2),
    communityAlgo = _useState2[0],
    setCommunityAlgo = _useState2[1];
  var _useState3 = (0, _react.useState)(null),
    _useState4 = _slicedToArray(_useState3, 2),
    resData = _useState4[0],
    setResData = _useState4[1];
  var _useState5 = (0, _react.useState)({
      nodes: [],
      edges: []
    }),
    _useState6 = _slicedToArray(_useState5, 2),
    initData = _useState6[0],
    setInitData = _useState6[1];
  var _useState7 = (0, _react.useState)(2),
    _useState8 = _slicedToArray(_useState7, 2),
    coreDegreeK = _useState8[0],
    setCoreDegreeK = _useState8[1];
  var _useState9 = (0, _react.useState)(false),
    _useState10 = _slicedToArray(_useState9, 2),
    hasAnalysis = _useState10[0],
    setHasAnalysis = _useState10[1];
  var _useState11 = (0, _react.useState)(null),
    _useState12 = _slicedToArray(_useState11, 2),
    hulls = _useState12[0],
    setHulls = _useState12[1];
  var _useState13 = (0, _react.useState)(false),
    _useState14 = _slicedToArray(_useState13, 2),
    loading = _useState14[0],
    setLoading = _useState14[1];
  var _useState15 = (0, _react.useState)(null),
    _useState16 = _slicedToArray(_useState15, 2),
    focusNodeId = _useState16[0],
    setFocusNodeId = _useState16[1];
  var _useState17 = (0, _react.useState)([]),
    _useState18 = _slicedToArray(_useState17, 2),
    allClusters = _useState18[0],
    setAllClusters = _useState18[1];
  var _useState19 = (0, _react.useState)([]),
    _useState20 = _slicedToArray(_useState19, 2),
    nodeProperties = _useState20[0],
    setNodeProperties = _useState20[1];
  var divisionAlgo = [CommunityDetectionAlgorithm.louvain, CommunityDetectionAlgorithm.iLouvain, CommunityDetectionAlgorithm.ConnectedComponent];
  /**
   * 受控参数变化，自动进行分析
   * e.g. ChatGPT，历史记录模版等
   */
  (0, _react.useEffect)(function () {
    if (controlledValues) {
      var algorithm = controlledValues.algorithm,
        controlledCoreK = controlledValues.coreDegreeK;
      setCommunityAlgo(algorithm);
      if (controlledCoreK) setCoreDegreeK(controlledCoreK);
      onCommunityAnalyse(controlledValues);
      onOpen === null || onOpen === void 0 ? void 0 : onOpen();
    }
  }, [controlledValues]);
  (0, _react.useEffect)(function () {
    setInitData({
      //@ts-ignore
      nodes: (0, _lodash.cloneDeep)(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      //@ts-ignore
      edges: (0, _lodash.cloneDeep)(graph.getEdges()).map(function (edge) {
        var model = edge.getModel();
        return Object.assign(Object.assign({}, model), {
          //@ts-ignore
          id: model.id || model.data.id
        });
      })
    });
    var nodePropertyMap = {};
    data.nodes.forEach(function (node) {
      Object.keys(node.data).forEach(function (key) {
        return nodePropertyMap[key] = true;
      });
    });
    setNodeProperties(Object.keys(nodePropertyMap));
  }, [data]);
  var communityAlgoSelections = [{
    name: CommunityDetectionAlgorithm.KCore,
    content: /*#__PURE__*/_react.default.createElement("div", {
      className: "community-detection-algo-body"
    }, /*#__PURE__*/_react.default.createElement("span", null, _i18n.default.get({
      id: 'gi-assets-algorithm.src.CommunityDetection.Component.SetCoreK',
      dm: '设置核心度k：'
    })), /*#__PURE__*/_react.default.createElement(_antd.InputNumber, {
      min: 1,
      value: coreDegreeK,
      style: {
        margin: '10px 20px'
      },
      onChange: function onChange(value) {
        return setCoreDegreeK(value);
      }
    }))
  }, {
    name: CommunityDetectionAlgorithm.louvain,
    content: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null)
  }, {
    name: CommunityDetectionAlgorithm.iLouvain,
    content: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null)
  }, {
    name: CommunityDetectionAlgorithm.ConnectedComponent,
    content: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null)
  }];
  var removeAllHulls = function removeAllHulls() {
    _index.default.removeHulls(hulls, graph);
    setHulls(null);
  };
  var drawHullsByClusters = function drawHullsByClusters(clusters, remove, focusClusterId) {
    if (remove) {
      removeAllHulls();
    }
    var hullOptions = clusters.map(function (cluster) {
      return {
        id: cluster.id,
        type: 'smooth-convex',
        members: cluster.nodes.map(function (node) {
          return node.id;
        }),
        style: cluster.id === focusClusterId ? {
          fill: 'lightgreen',
          stroke: 'green'
        } : undefined
      };
    }).map(function (cluster) {
      return _index.default.getHullOptions(cluster);
    });
    var newHulls = _index.default.drawHulls(hullOptions, remove ? null : hulls, graph);
    setHulls(newHulls);
  };
  var resetMapping = function resetMapping(mappedNodeIds, mappedEdgeIds) {
    graph.getNodes().forEach(function (node) {
      var _a, _b;
      var id = node.get('id');
      var initModel = (_a = initData.nodes) === null || _a === void 0 ? void 0 : _a.find(function (initNode) {
        return initNode.id === id;
      });
      if (initModel && !(mappedNodeIds === null || mappedNodeIds === void 0 ? void 0 : mappedNodeIds.includes(id))) {
        var _ref = ((_b = initModel.style) === null || _b === void 0 ? void 0 : _b.keyshape) || {
            size: 30
          },
          size = _ref.size;
        graph.updateItem(node, {
          style: {
            keyshape: {
              size: size
            },
            icon: {
              size: size && size / 2
            }
          }
        });
      }
    });
    if (mappedEdgeIds) {
      graph.getEdges().forEach(function (edge) {
        var _a, _b;
        //@ts-ignore
        var id = edge.getModel().id || '';
        var initModel = (_a = initData.edges) === null || _a === void 0 ? void 0 : _a.find(function (initEdge) {
          return initEdge.id === id;
        });
        // 暂时这样处理: 目前GI的导入的数据edge没有id，会自动生成，数据里的edge id和graph中edge id对不上
        var keyShapeStyle = (_b = initModel === null || initModel === void 0 ? void 0 : initModel.style) === null || _b === void 0 ? void 0 : _b.keyshape;
        // @ts-ignore
        var lineWidth = keyShapeStyle === null || keyShapeStyle === void 0 ? void 0 : keyShapeStyle.lineWidth;
        if (initModel && !(mappedEdgeIds === null || mappedEdgeIds === void 0 ? void 0 : mappedEdgeIds.includes(id))) {
          graph.updateItem(edge, {
            style: {
              keyshape: Object.assign({
                lineWidth: lineWidth
              }, keyShapeStyle || {})
            }
          });
        }
      });
    }
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var formatOriginData = function formatOriginData(_ref2) {
    var _ref2$nodes = _ref2.nodes,
      nodes = _ref2$nodes === void 0 ? [] : _ref2$nodes,
      _ref2$edges = _ref2.edges,
      edges = _ref2$edges === void 0 ? [] : _ref2$edges;
    return {
      nodes: nodes.map(function (node) {
        var _a;
        return Object.assign(Object.assign({}, node.data || {}), {
          properties: Object.assign({}, ((_a = node === null || node === void 0 ? void 0 : node.data) === null || _a === void 0 ? void 0 : _a.properties) || {}),
          label: node.label || node.data.label || node.data.name,
          id: node.id
        });
      }),
      edges: edges.map(function (edge) {
        return Object.assign(Object.assign(Object.assign({}, edge), edge.data || {}), {
          id: edge.id || edge.data.id
        });
      })
    };
  };
  var onCommunityAnalyse = function onCommunityAnalyse() {
    var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    setHasAnalysis(true);
    setLoading(true);
    setTimeout(function () {
      var _a;
      if (!graph || graph.destroyed) {
        handleUpateHistory(false, _i18n.default.get({
          id: 'gi-assets-algorithm.src.CommunityDetection.Component.TheGraphInstanceDoesNot',
          dm: '图实例不存在'
        }));
        return;
      }
      var formatData = formatOriginData(data);
      switch (values.algorithm || communityAlgo) {
        case CommunityDetectionAlgorithm.KCore:
          //@ts-ignore
          var coreData = (0, _algorithm.kCore)(formatData, values.coreDegreeK || coreDegreeK) || {
            nodes: [],
            edges: []
          };
          var coreNodeIds = coreData.nodes.map(function (node) {
            return node.id;
          });
          var coreEdgeIds = coreData.edges.map(function (edge) {
            return edge.id;
          });
          var nodes = initData === null || initData === void 0 ? void 0 : initData.nodes.filter(function (node) {
            return coreNodeIds.includes(node.id);
          });
          var edges = (initData === null || initData === void 0 ? void 0 : initData.edges.filter(function (edge) {
            var _a;
            var id = ((_a = edge.data) === null || _a === void 0 ? void 0 : _a.id) || edge.id;
            return coreEdgeIds.includes(id);
          })) || [];
          var scaleData = {
            nodes: nodes,
            edges: edges
          };
          // 如果相隔较远，x、y等比缩放
          if (nodes.length !== ((_a = initData === null || initData === void 0 ? void 0 : initData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
            //@ts-ignore
            scaleData = _index.default.scaleNodes(scaleData, 600);
          }
          setResData(scaleData);
          resetMapping([], []);
          // 将主图中的相关节点和边放大
          coreData.nodes.forEach(function (nodeModel) {
            graph.updateItem(nodeModel.id, {
              style: {
                keyshape: {
                  size: 50
                },
                icon: {
                  size: 50
                }
              }
            });
          });
          coreData.edges.forEach(function (edgeData) {
            // 暂时这样处理: 目前GI的导入的数据edge没有id，会自动生成，数据里的edge id和graph中edge id对不上
            var edge = graph.getEdges()
            //@ts-ignore
            .find(function (edge) {
              return edge.getModel().data.id === edgeData.data.id;
            });
            if (!edge) return;
            var _edge$getModel = edge.getModel(),
              _edge$getModel$style = _edge$getModel.style,
              style = _edge$getModel$style === void 0 ? {} : _edge$getModel$style;
            //@ts-ignore
            graph.updateItem(edge, {
              style: {
                keyshape: Object.assign({
                  lineWidth: 2
                }, style.keyshape || {})
              }
            });
          });
          graph.getEdges().forEach(function (edge) {
            edge.refresh();
          });
          break;
        case CommunityDetectionAlgorithm.louvain:
          var clustersLouvain = (0, _algorithm.louvain)(formatData, false, 'weight', 0.01).clusters;
          setResData(formatData);
          setAllClusters(clustersLouvain);
          drawHullsByClusters(clustersLouvain);
          break;
        case CommunityDetectionAlgorithm.iLouvain:
          var clustersILouvain = (0, _algorithm.iLouvain)(formatData, false, 'weight', 0.01,
          //@ts-ignore
          'properties').clusters;
          setResData(formatData);
          setAllClusters(clustersILouvain);
          drawHullsByClusters(clustersILouvain);
          break;
        case CommunityDetectionAlgorithm.ConnectedComponent:
          var components = (0, _algorithm.connectedComponent)(formatData);
          if (components.length <= 1) {
            _antd.message.info(_i18n.default.get({
              id: 'gi-assets-algorithm.src.CommunityDetection.Component.TheCurrentGraphIsConnected',
              dm: '当前图整体连通，无非连通子图'
            }));
            break;
          }
          var clustersComponent = [];
          var existSingleNode = false;
          components.forEach(function (componentNodes, i) {
            if (componentNodes.length === 1) {
              existSingleNode = true;
              return;
            }
            componentNodes.forEach(function (node) {
              return node.clusterId = "".concat(i);
            });
            clustersComponent.push({
              id: "".concat(i),
              nodes: componentNodes
            });
          });
          if (existSingleNode) {
            _antd.message.info(_i18n.default.get({
              id: 'gi-assets-algorithm.src.CommunityDetection.Component.ThereAreIsolatedPointOn',
              dm: '当前图上存在孤点，将不参与社区划分'
            }));
          }
          setResData(formatData);
          setAllClusters(clustersComponent);
          drawHullsByClusters(clustersComponent);
          break;
        default:
          break;
      }
      handleUpateHistory(true);
      setLoading(false);
    }, 100);
  };
  /**
   * 更新到历史记录
   * @param success 是否成功
   * @param errorMsg 若失败，填写失败信息
   * @param value 查询语句
   */
  var handleUpateHistory = function handleUpateHistory(success, errorMsg) {
    var params = {
      communityAlgo: communityAlgo
    };
    if (communityAlgo === CommunityDetectionAlgorithm.KCore) {
      params.coreDegreeK = coreDegreeK;
    }
    updateHistory({
      componentId: 'CommunityDetection',
      type: 'analyse',
      subType: _i18n.default.get({
        id: 'gi-assets-algorithm.src.CommunityDetection.Component.CommunityDiscovery',
        dm: '社区发现'
      }),
      statement: communityAlgo,
      success: success,
      errorMsg: errorMsg,
      params: params
    });
  };
  var cleatActiveState = function cleatActiveState() {
    if (focusNodeId) {
      var focusNode = graph.findById(focusNodeId);
      if (focusNode.hasState('active')) {
        graph.setItemState(focusNodeId, 'active', false);
      }
    }
  };
  var focusNodeAndHighlightHull = function focusNodeAndHighlightHull(nodeId, focusClusterId) {
    cleatActiveState();
    graph.setItemState(nodeId, 'active', true);
    drawHullsByClusters(allClusters, true, focusClusterId);
    setFocusNodeId(nodeId);
  };
  var renderResult = function renderResult() {
    var _a;
    if (!hasAnalysis) {
      return;
    }
    if (loading) {
      return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
        spinning: true
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "kg-community-result-wrapper"
      }));
    }
    if (!((_a = resData === null || resData === void 0 ? void 0 : resData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
      return /*#__PURE__*/_react.default.createElement(_antd.Empty, {
        image: _antd.Empty.PRESENTED_IMAGE_SIMPLE,
        description: _i18n.default.get({
          id: 'gi-assets-algorithm.src.CommunityDetection.Component.NoDataAvailable',
          dm: '暂无数据'
        })
      });
    }
    if (divisionAlgo.includes(communityAlgo)) {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "community-detection-result-wrapper"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "community-detection-title"
      }, _i18n.default.get({
        id: 'gi-assets-algorithm.src.CommunityDetection.Component.AnalysisResults',
        dm: '分析结果'
      })), /*#__PURE__*/_react.default.createElement(_ClusterTable.default, {
        data: resData,
        clusterTitle: _i18n.default.get({
          id: 'gi-assets-algorithm.src.CommunityDetection.Component.CommunityNumber',
          dm: '社区编号'
        }),
        focusNodeAndHighlightHull: focusNodeAndHighlightHull,
        properties: nodeProperties
      }));
    }
    if (communityAlgo === CommunityDetectionAlgorithm.KCore) {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "community-detection-result-wrapper"
      }, /*#__PURE__*/_react.default.createElement("p", {
        className: "community-detection-title"
      }, _i18n.default.get({
        id: 'gi-assets-algorithm.src.CommunityDetection.Component.AnalysisResults',
        dm: '分析结果'
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "community-detection-graph-container"
      }, /*#__PURE__*/_react.default.createElement(_graphin.default, {
        data: resData,
        height: 300,
        layout: {
          type: 'preset'
        },
        fitView: true,
        animate: false,
        minZoom: 0.1,
        layoutCache: true
      }, /*#__PURE__*/_react.default.createElement(ClickSelect, {
        disabled: true
      }))));
    }
  };
  var changeAlgo = function changeAlgo(e) {
    resetMapping([], []);
    setResData(null);
    removeAllHulls();
    setCommunityAlgo(e.target.value);
  };
  var reset = function reset() {
    resetMapping([], []);
    setResData(null);
    removeAllHulls();
    setCommunityAlgo(CommunityDetectionAlgorithm.KCore);
    cleatActiveState();
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      background: '#fff'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "community-detection-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "top-info"
  }, /*#__PURE__*/_react.default.createElement("p", {
    className: "community-detection-title"
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.CommunityDetection.Component.SelectionAlgorithm',
    dm: '选择算法'
  })), /*#__PURE__*/_react.default.createElement(_icons.ReloadOutlined, {
    onClick: reset
  })), /*#__PURE__*/_react.default.createElement(_antd.Radio.Group, {
    onChange: changeAlgo,
    value: communityAlgo
  }, communityAlgoSelections.map(function (selection) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: selection.name
    }, /*#__PURE__*/_react.default.createElement(_antd.Radio, {
      value: selection.name,
      className: "community-detection-algo-radio"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "community-detection-algo-title"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "community-detection-algo-title-name"
    }, selection.name), /*#__PURE__*/_react.default.createElement("span", {
      className: "community-detection-algo-title-tip"
    }, selection.name))), selection.content);
  })), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "primary",
    style: {
      width: '100%',
      marginTop: '12px'
    },
    loading: loading,
    onClick: function onClick() {
      return onCommunityAnalyse();
    }
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.CommunityDetection.Component.Analysis',
    dm: '分析'
  })), renderResult()));
};
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(CommunityDetection);