"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.locale = exports.default = exports.MappingWay = exports.ITEM_STATE = void 0;
var _giSdk = require("@antv/gi-sdk");
var _info = _interopRequireDefault(require("./info"));
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var locale = exports.locale = {
  degree: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.DegreeCentrality',
    dm: '度中心性'
  }),
  'degree-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.CalculatedBasedOnTheEntity',
    dm: '根据实体的出入度大小计算'
  }),
  'page-rank': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.PagerankWebPageSorting',
    dm: 'PageRank网页排序'
  }),
  'page-rank-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.UsePagerankWebPageSorting',
    dm: '使用PageRank网页排序算法计算'
  }),
  'node-property': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.NodeAttributeImportance',
    dm: '节点属性重要性'
  }),
  'node-property-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.CalculateBasedOnNodeAttribute',
    dm: '根据节点属性值计算'
  }),
  'edge-property': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.ImportanceOfRelationshipAttributes',
    dm: '关系属性重要性'
  }),
  'edge-property-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.CalculatedBasedOnTheAttributes',
    dm: '根据节点相关关系的属性计算'
  }),
  'in-degree': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Penetration',
    dm: '入度'
  }),
  'out-degree': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Outdegree',
    dm: '出度'
  }),
  ave: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Average',
    dm: '平均数'
  }),
  min: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.MinimumValue',
    dm: '最小值'
  }),
  max: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Maximum',
    dm: '最大值'
  }),
  median: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Median',
    dm: '中位数'
  }),
  sort: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Sort',
    dm: '排序'
  }),
  'sort-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.ApplicableToNumericalType',
    dm: '适用于数值型'
  }),
  count: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.Count',
    dm: '计数'
  }),
  'count-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.ApplicableToEnumeratedTypes',
    dm: '适用于枚举型'
  }),
  'positive-correlation': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.PositiveCorrelation',
    dm: '正相关'
  }),
  'positive-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.TheLargerTheValueThe',
    dm: '值越大，点或边越大'
  }),
  'negative-correlation': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.PositiveCorrelation',
    dm: '正相关'
  }),
  'negative-tip': _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.registerMeta.TheSmallerTheValueThe',
    dm: '值越小，点或边越大'
  })
};
var MappingWay;
(function (MappingWay) {
  MappingWay["Positive"] = "positive";
  MappingWay["Negative"] = "negative";
})(MappingWay || (exports.MappingWay = MappingWay = {}));
var ITEM_STATE;
(function (ITEM_STATE) {
  ITEM_STATE["Active"] = "active";
  ITEM_STATE["Default"] = "default";
  ITEM_STATE["Selected"] = "selected";
  ITEM_STATE["Disable"] = "disable";
  ITEM_STATE["Highlight"] = "highlight";
  ITEM_STATE["Inactive"] = "inactive";
})(ITEM_STATE || (exports.ITEM_STATE = ITEM_STATE = {}));
var GIAC_CONTENT_METAS = _giSdk.extra.GIAC_CONTENT_METAS,
  deepClone = _giSdk.extra.deepClone;
var metas = deepClone(GIAC_CONTENT_METAS);
metas.GIAC_CONTENT.properties.GIAC_CONTENT.properties.title.default = _info.default.name;
metas.GIAC_CONTENT.properties.GIAC_CONTENT.properties.icon.default = _info.default.icon;
var _default = exports.default = function _default() {
  return Object.assign({}, metas);
};