"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NodesClusteringAlgorithm = exports.DistanceType = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = require("@antv/algorithm");
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
var _ClusterTable = _interopRequireDefault(require("../ClusterTable"));
var _i18n = _interopRequireDefault(require("../i18n"));
require("./index.less");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var NodesClusteringAlgorithm;
(function (NodesClusteringAlgorithm) {
  NodesClusteringAlgorithm["KMeans"] = "k-means";
})(NodesClusteringAlgorithm || (exports.NodesClusteringAlgorithm = NodesClusteringAlgorithm = {}));
var DistanceType;
(function (DistanceType) {
  DistanceType["EuclideanDistance"] = "euclideanDistance";
})(DistanceType || (exports.DistanceType = DistanceType = {}));
var NodesClustering = function NodesClustering(props) {
  var controlledValues = props.controlledValues,
    onOpen = props.onOpen;
  var context = (0, _giSdk.useContext)();
  var data = context.data,
    graph = context.graph,
    layout = context.layout,
    updateContext = context.updateContext,
    updateHistory = context.updateHistory;
  var _useState = (0, _react.useState)(NodesClusteringAlgorithm.KMeans),
    _useState2 = _slicedToArray(_useState, 2),
    nodeClusteringAlgo = _useState2[0],
    setNodeClusteringAlgo = _useState2[1];
  var _useState3 = (0, _react.useState)(null),
    _useState4 = _slicedToArray(_useState3, 2),
    resData = _useState4[0],
    setResData = _useState4[1];
  var _useState5 = (0, _react.useState)({
      nodes: [],
      edges: []
    }),
    _useState6 = _slicedToArray(_useState5, 2),
    initData = _useState6[0],
    setInitData = _useState6[1];
  var _useState7 = (0, _react.useState)(2),
    _useState8 = _slicedToArray(_useState7, 2),
    clusterK = _useState8[0],
    setClusterK = _useState8[1];
  var _useState9 = (0, _react.useState)(DistanceType.EuclideanDistance),
    _useState10 = _slicedToArray(_useState9, 2),
    distanceType = _useState10[0],
    setDistanceType = _useState10[1];
  var _useState11 = (0, _react.useState)(false),
    _useState12 = _slicedToArray(_useState11, 2),
    hasAnalysis = _useState12[0],
    setHasAnalysis = _useState12[1];
  var _useState13 = (0, _react.useState)(false),
    _useState14 = _slicedToArray(_useState13, 2),
    loading = _useState14[0],
    setLoading = _useState14[1];
  var _useState15 = (0, _react.useState)(null),
    _useState16 = _slicedToArray(_useState15, 2),
    focusNodeId = _useState16[0],
    setFocusNodeId = _useState16[1];
  var _useState17 = (0, _react.useState)({
      nodes: [],
      edges: []
    }),
    _useState18 = _slicedToArray(_useState17, 2),
    prevData = _useState18[0],
    setPrevData = _useState18[1];
  var _useState19 = (0, _react.useState)(layout),
    _useState20 = _slicedToArray(_useState19, 2),
    prevLayout = _useState20[0],
    setPrevLayout = _useState20[1];
  var getInitData = function getInitData() {
    if (!graph || graph.destroyed) {
      return {
        nodes: [],
        edges: []
      };
    }
    return {
      nodes: (0, _lodash.cloneDeep)(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      edges: (0, _lodash.cloneDeep)(graph.getEdges()).map(function (edge) {
        return edge.getModel();
      })
    };
  };
  (0, _react.useEffect)(function () {
    if (!graph || graph.destroyed) return;
    setInitData({
      //@ts-ignore
      nodes: (0, _lodash.cloneDeep)(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      //@ts-ignore
      edges: (0, _lodash.cloneDeep)(graph.getEdges()).map(function (edge) {
        var model = edge.getModel();
        return Object.assign(Object.assign({}, model), {
          //@ts-ignore
          id: model.id || model.data.id
        });
      })
    });
  }, [data, graph]);
  /**
   * 受控参数变化，自动进行分析
   * e.g. ChatGPT，历史记录模版等
   */
  (0, _react.useEffect)(function () {
    if (controlledValues) {
      var algorithm = controlledValues.algorithm,
        controlledClusterK = controlledValues.clusterK,
        controlledDistanceType = controlledValues.distanceType,
        controlledFocusNodeId = controlledValues.focusNodeId;
      setNodeClusteringAlgo(algorithm);
      setClusterK(controlledClusterK);
      setDistanceType(controlledDistanceType);
      onOpen === null || onOpen === void 0 ? void 0 : onOpen();
      onAnalyse();
      if (controlledFocusNodeId) {
        focusNodeAndHighlightHull(controlledFocusNodeId);
      }
    }
  }, [controlledValues]);
  var formatOriginData = function formatOriginData(_ref) {
    var _ref$nodes = _ref.nodes,
      nodes = _ref$nodes === void 0 ? [] : _ref$nodes,
      _ref$edges = _ref.edges,
      edges = _ref$edges === void 0 ? [] : _ref$edges;
    return {
      nodes: nodes.map(function (node) {
        var properties = Object.assign({}, node.data, node.data.properties);
        delete properties.id;
        return {
          id: node.id,
          label: node.label || node.data.label || node.data.name,
          properties: properties
        };
      }),
      edges: edges.map(function (edge) {
        return Object.assign(Object.assign({}, edge), {
          id: edge.id || edge.data.id
        });
      })
    };
  };
  var transDataWithCombo = function transDataWithCombo(graphData, clusters) {
    var comboNodeMap = {};
    clusters.forEach(function (cluster, index) {
      cluster.forEach(function (node) {
        comboNodeMap[node.id] = "gi-kmeans-combo-".concat(String(index));
      });
    });
    return {
      nodes: graphData === null || graphData === void 0 ? void 0 : graphData.nodes.map(function (node) {
        return Object.assign(Object.assign({}, node), {
          comboId: comboNodeMap[node.id],
          x: undefined,
          y: undefined
        });
      }),
      edges: graphData === null || graphData === void 0 ? void 0 : graphData.edges,
      combos: clusters.map(function (cluster, index) {
        return {
          id: "gi-kmeans-combo-".concat(String(index)),
          label: _i18n.default.get({
            id: 'gi-assets-algorithm.src.NodesClustering.Component.CategoryIndex',
            dm: '分类{index}'
          }, {
            index: index
          })
        };
      })
    };
  };
  var onAnalyse = function onAnalyse() {
    setHasAnalysis(true);
    setLoading(true);
    setTimeout(function () {
      var formatData = formatOriginData(data);
      switch (nodeClusteringAlgo) {
        case NodesClusteringAlgorithm.KMeans:
          if (!graph || graph.destroyed) {
            return;
          }
          var _kMeans = (0, _algorithm.kMeans)(formatData,
            //@ts-ignore
            clusterK,
            //@ts-ignore
            'properties', [], [], distanceType),
            clusters = _kMeans.clusters;
          setResData(formatData);
          var newData = transDataWithCombo(data, clusters);
          setPrevData(newData);
          updateContext(function (draft) {
            draft.data = newData;
          });
          break;
        default:
          break;
      }
      setLoading(false);
      updateHistory({
        componentId: 'NodesClustering',
        type: 'analyse',
        subType: _i18n.default.get({
          id: 'gi-assets-algorithm.src.NodesClustering.Component.NodeClustering',
          dm: '节点聚类'
        }),
        statement: _i18n.default.get({
          id: 'gi-assets-algorithm.src.NodesClustering.Component.AlgorithmNodeclusteringalgo',
          dm: '算法 {nodeClusteringAlgo}'
        }, {
          nodeClusteringAlgo: nodeClusteringAlgo
        }),
        success: true,
        params: {
          algorithm: nodeClusteringAlgo,
          clusterK: clusterK,
          distanceType: distanceType,
          focusNodeId: focusNodeId
        }
      });
    }, 100);
  };
  var renderResult = function renderResult() {
    var _a;
    if (!hasAnalysis) {
      return;
    }
    if (loading) {
      return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
        spinning: true
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "kg-nodes-clustering-result-wrapper"
      }));
    }
    if (!((_a = resData === null || resData === void 0 ? void 0 : resData.nodes) === null || _a === void 0 ? void 0 : _a.length)) {
      return /*#__PURE__*/_react.default.createElement(_antd.Empty, {
        image: _antd.Empty.PRESENTED_IMAGE_SIMPLE,
        description: _i18n.default.get({
          id: 'gi-assets-algorithm.src.NodesClustering.Component.NoDataAvailable',
          dm: '暂无数据'
        })
      });
    }
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "nodes-clustering-result-wrapper"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "intelligent-analysis-title nodes-clustering-result-title"
    }, _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodesClustering.Component.AnalysisResults',
      dm: '分析结果'
    })), /*#__PURE__*/_react.default.createElement(_ClusterTable.default, {
      data: resData,
      clusterTitle: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesClustering.Component.Classification',
        dm: '分类'
      }),
      focusNodeAndHighlightHull: focusNodeAndHighlightHull
    }));
  };
  var clearActiveState = function clearActiveState() {
    if (focusNodeId) {
      var focusNode = graph.findById(focusNodeId);
      if (focusNode.hasState('active')) {
        graph.setItemState(focusNodeId, 'active', false);
      }
    }
  };
  var focusNodeAndHighlightHull = function focusNodeAndHighlightHull(nodeId) {
    var focusClusterId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    clearActiveState();
    var node = graph.findById(nodeId);
    if (node) {
      graph.setItemState(node, 'active', true);
      setFocusNodeId(nodeId);
    }
  };
  var reset = function reset() {
    setResData({
      nodes: [],
      edges: []
    });
    setNodeClusteringAlgo(NodesClusteringAlgorithm.KMeans);
    setClusterK(2);
    clearActiveState();
    updateContext(function (draft) {
      draft.data = initData;
      draft.layout = prevLayout;
    });
  };
  (0, _react.useEffect)(function () {
    if (!(0, _lodash.isEqual)(data, prevData)) {
      // @ts-ignore
      setInitData(getInitData());
      // 源数据变化，清空当前结果
      setResData({
        nodes: [],
        edges: []
      });
      clearActiveState();
      updateContext(function (draft) {
        draft.layout = prevLayout;
      });
    }
    // @ts-ignore
    setPrevData((0, _lodash.cloneDeep)(data));
  }, [data, graph]);
  (0, _react.useEffect)(function () {
    //@ts-ignore
    setInitData(getInitData());
    //@ts-ignore
    setPrevLayout(layout);
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-clustering-wrapper"
  }, /*#__PURE__*/_react.default.createElement(_antd.Row, {
    justify: "space-between"
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 21
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-clustering-algo-title"
  }, /*#__PURE__*/_react.default.createElement("h4", {
    className: "nodes-clustering-algo-title-name"
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesClustering.Component.NodesclusteringalgorithmkmeansAlgorithm',
    dm: '{NodesClusteringAlgorithmKMeans}算法'
  }, {
    NodesClusteringAlgorithmKMeans: NodesClusteringAlgorithm.KMeans
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-clustering-algo-title-tip"
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesClustering.Component.GatherNodesIntoKClusters',
    dm: '根据节点之间的距离将节点聚成K个簇'
  })))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 2,
    offset: 1,
    style: {
      lineHeight: '32px',
      textAlign: 'right'
    }
  }, /*#__PURE__*/_react.default.createElement(_icons.ReloadOutlined, {
    onClick: reset
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-clustering-algo-body"
  }, /*#__PURE__*/_react.default.createElement("span", null, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesClustering.Component.SetTheKValue',
    dm: '设置 K 值'
  })), /*#__PURE__*/_react.default.createElement(_antd.InputNumber, {
    min: 1,
    value: clusterK,
    style: {
      margin: '10px 20px'
    },
    onChange: function onChange(value) {
      return setClusterK(value);
    }
  })), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "primary",
    style: {
      width: '100%',
      marginTop: '12px'
    },
    loading: loading,
    onClick: onAnalyse
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesClustering.Component.Analysis',
    dm: '分析'
  })), renderResult()));
};
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(NodesClustering);