"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _icons = require("@ant-design/icons");
var _giSdk = require("@antv/gi-sdk");
var _graphin = _interopRequireWildcard(require("@antv/graphin"));
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _utils = _interopRequireDefault(require("../utils"));
require("./index.less");
var _util = require("./util");
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var exportGraphData = _utils.default.exportGraphData;
var ClickSelect = _graphin.Behaviors.ClickSelect;
var PatternPane = function PatternPane(_ref) {
  var id = _ref.id,
    data = _ref.data,
    schemaEdgeMap = _ref.schemaEdgeMap,
    editPattern = _ref.editPattern,
    extractPattern = _ref.extractPattern,
    importData = _ref.importData;
  var _a, _b, _c, _d;
  var _useContext = (0, _giSdk.useContext)(),
    config = _useContext.config;
  var graphRef = (0, _react.useRef)();
  // 数据发生变化，fitView
  (0, _react.useEffect)(function () {
    var _a;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (graph && !graph.destroyed) {
      graph.once('afterlayout', function (e) {
        graph.fitView();
      });
      graph.fitView();
      graph.get('canvas').set('localRefresh', false);
    }
  }, [data]);
  (0, _react.useEffect)(function () {
    var _a;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (graph && !graph.destroyed) {
      graph.changeSize(456, 246);
    }
  }, [(_b = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph) === null || _b === void 0 ? void 0 : _b.get('width'), (_d = (_c = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _c === void 0 ? void 0 : _c.graph) === null || _d === void 0 ? void 0 : _d.get('height')]);
  /**
   * 下载模式数据到本地 json 文件，方便下次上传
   */
  var downloadPatternData = function downloadPatternData() {
    var _a;
    var graph = (_a = graphRef === null || graphRef === void 0 ? void 0 : graphRef.current) === null || _a === void 0 ? void 0 : _a.graph;
    if (graph && !graph.destroyed) {
      exportGraphData(graph.save(), 'pattern-data');
    }
  };
  /**
   * 导入 json 图数据
   * @param result
   * @returns
   */
  var importPattern = function importPattern(result) {
    var fileInfo = result.file;
    var _ref2 = fileInfo || {},
      status = _ref2.status,
      type = _ref2.type,
      name = _ref2.name,
      file = _ref2.originFileObj;
    if (status !== 'uploading') {
      return;
    }
    if (type === 'json' || name.includes('.json')) {
      var fReader = new FileReader();
      fReader.onload = function () {
        if (typeof fReader.result === 'string') {
          var _data = JSON.parse(fReader.result);
          importData === null || importData === void 0 ? void 0 : importData(_data, id);
        }
      };
      fReader.readAsText(file);
    } else {
      _antd.message.error(_i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.patternPane.PleaseUploadDataInJson',
        dm: '请上传 JSON 格式的数据'
      }));
    }
  };
  var buildPatternMenuItems = [/*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    onClick: function onClick() {
      return editPattern === null || editPattern === void 0 ? void 0 : editPattern(id);
    }
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.patternPane.EditMode',
    dm: '编辑模式'
  })), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    onClick: function onClick() {
      return extractPattern === null || extractPattern === void 0 ? void 0 : extractPattern(id);
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatch.patternPane.DragOrClickTheContent',
      dm: '从主图上拖拽圈选或点选内容并抽取为模式'
    })
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.patternPane.ExtractionMode',
    dm: '提取模式'
  }))), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, null, /*#__PURE__*/_react.default.createElement(_antd.Upload, {
    accept: ".json,.txt",
    onChange: importPattern,
    fileList: []
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.patternPane.ImportMode',
    dm: '导入模式'
  })))];
  var modifyPatternMenuItems = buildPatternMenuItems.concat( /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
    onClick: downloadPatternData
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.patternPane.DownloadMode',
    dm: '下载模式'
  })));
  var buildPatternMenu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, buildPatternMenuItems);
  var modifyPatternMenu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, modifyPatternMenuItems);
  var graphData = (0, _react.useMemo)(function () {
    return data ? (0, _util.formatData)(data, config, schemaEdgeMap) : {
      nodes: [],
      edges: []
    };
  }, [data]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-pane-content"
  }, data ? /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-pattern-pane-graph"
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: modifyPatternMenu,
    className: "kg-pattern-pane-edit"
  }, /*#__PURE__*/_react.default.createElement("a", {
    onClick: function onClick(e) {
      return e.preventDefault();
    }
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatch.patternPane.BuildMode',
    dm: '构建模式'
  }), /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null))), /*#__PURE__*/_react.default.createElement(_graphin.default, {
    width: 388,
    height: 246,
    data: graphData,
    ref: graphRef,
    animate: false,
    minZoom: 0.001,
    fitView: true
  }, /*#__PURE__*/_react.default.createElement(ClickSelect, {
    disabled: true
  }))) : /*#__PURE__*/_react.default.createElement(_antd.Empty, {
    className: "kg-pattern-empty",
    image: _antd.Empty.PRESENTED_IMAGE_SIMPLE,
    description: /*#__PURE__*/_react.default.createElement("span", null, _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatch.patternPane.NoMode',
      dm: '暂无模式'
    }), /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
      overlay: buildPatternMenu
    }, /*#__PURE__*/_react.default.createElement("a", {
      onClick: function onClick(e) {
        return e.preventDefault();
      }
    }, _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatch.patternPane.BuildMode',
      dm: '构建模式'
    }), /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null))))
  }));
};
var _default = exports.default = PatternPane;