/**
 * update instance of intl universal
 */
declare function update(): void;
/**
 * change current language
 * @param {string} langTag language tag config above
 */
declare function change(langTag: any): void;
/**
 * Format string by key
 * For example:
 * $i18n.get('jsx.home.title'),
 * $i18n.get({
 *    id: 'jsx.home.hello',
 *    defaultMessage: 'Hello {name}' // not required
 * },{
 *  name: 'Alice'
 * })
 * More syntax: https://formatjs.io/guides/message-syntax/
 * @param {string|object} id key or object
 * @param {object} variable variable for id
 * @return {string} format message
 */
declare function get(id: any, variable?: {}): string;
declare const _default: {
    get: typeof get;
    update: typeof update;
    change: typeof change;
    language: any;
};
export default _default;
